IRremoteESP8266

Public Member Functions | Static Public Member Functions | List of all members
IRHaierACYRW02 Class Reference

Class for handling detailed Haier ACYRW02 A/C messages. More...

`#include <ir_Haier.h>`

Inheritance diagram for IRHaierACYRW02:
[legend]
Collaboration diagram for IRHaierACYRW02:
[legend]

## Public Member Functions
| IRHaierACYRW02 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kHaierAcYrw02DefaultRepeat) override
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | setRaw (const uint8_t new_code[]) override
| Set the internal state from a valid code for this protocol. More...
Public Member Functions inherited from IRHaierAC176
| IRHaierAC176 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | setModel (const haier_ac176_remote_model_t model)
| Set the model of the A/C to emulate. More...
haier_ac176_remote_model_t | getModel (void) const
| Get/Detect the model of the A/C. More...
void | setButton (const uint8_t button)
| Set the Button/Command setting of the A/C. More...
uint8_t | getButton (void) const
| Get the Button/Command setting of the A/C. More...
void | setUseFahrenheit (const bool on)
| Set the default temperature units to use. More...
bool | getUseFahrenheit (void) const
| Get the default temperature units in use. More...
void | setTemp (const uint8_t temp, const bool fahrenheit=false)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. The unit of temperature is specified by UseFahrenheit value. More...
void | setFan (const uint8_t speed)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setPower (const bool on)
| Change the power setting. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
bool | getSleep (void) const
| Get the Sleep setting of the A/C. More...
void | setSleep (const bool on)
| Set the Sleep setting of the A/C. More...
bool | getHealth (void) const
| Get the Health (filter) setting of the A/C. More...
void | setHealth (const bool on)
| Set the Health (filter) setting of the A/C. More...
bool | getTurbo (void) const
| Get the Turbo setting of the A/C. More...
void | setTurbo (const bool on)
| Set the Turbo setting of the A/C. More...
bool | getQuiet (void) const
| Get the Quiet setting of the A/C. More...
void | setQuiet (const bool on)
| Set the Quiet setting of the A/C. More...
uint8_t | getSwingV (void) const
| Get the Vertical Swing position setting of the A/C. More...
void | setSwingV (const uint8_t pos)
| Set the Vertical Swing mode of the A/C. More...
uint8_t | getSwingH (void) const
| Get the Horizontal Swing position setting of the A/C. More...
void | setSwingH (const uint8_t pos)
| Set the Horizontal Swing mode of the A/C. More...
uint8_t | getSwing (void) const
| These functions are for backward compatibility. Use getSwingV() and setSwingV() instead. More...
void | setSwing (const uint8_t pos)
| For backward compatibility. Use setSwingV() instead. Set the Vertical Swing mode of the A/C. More...
void | setTimerMode (const uint8_t setting)
| Set the Timer operating mode. More...
uint8_t | getTimerMode (void) const
| Get the Timer operating mode. More...
void | setOnTimer (const uint16_t mins)
| Set the number of minutes of the On Timer setting. More...
uint16_t | getOnTimer (void) const
| Get the number of minutes of the On Timer setting. More...
void | setOffTimer (const uint16_t mins)
| Set the number of minutes of the Off Timer setting. More...
uint16_t | getOffTimer (void) const
| Get the number of minutes of the Off Timer setting. More...
bool | getLock (void) const
| Get the Lock setting of the A/C. More...
void | setLock (const bool on)
| Set the Lock setting of the A/C. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions
static bool | validChecksum (const uint8_t state[], const uint16_t length=kHaierACYRW02StateLength)
| Verify the checksum is valid for a given state. More...
Static Public Member Functions inherited from IRHaierAC176
static bool | validChecksum (const uint8_t state[], const uint16_t length=kHaierAC176StateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static uint8_t | convertSwingV (const stdAc::swingv_t position)
| Convert a stdAc::swingv_t enum into it's native setting. More...
static uint8_t | convertSwingH (const stdAc::swingh_t position)
| Convert a stdAc::swingh_t enum into it's native setting. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...
static stdAc::swingv_t | toCommonSwingV (const uint8_t pos)
| Convert a stdAc::swingv_t enum into it's native setting. More...
static stdAc::swingh_t | toCommonSwingH (const uint8_t pos)
| Convert a stdAc::swingh_t enum into it's native setting. More...
static bool | toCommonTurbo (const uint8_t speed)
static bool | toCommonQuiet (const uint8_t speed)

## Detailed Description

Class for handling detailed Haier ACYRW02 A/C messages.

## Constructor & Destructor Documentation

## ◆ IRHaierACYRW02()

IRHaierACYRW02::IRHaierACYRW02 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |
| explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ calibrate()

int8_t IRHaierACYRW02::calibrate | ( | void |  | ) |
| inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ send()

void IRHaierACYRW02::send | ( | const uint16_t | repeat = `kHaierAcYrw02DefaultRepeat` | ) |
| overridevirtual

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

Reimplemented from IRHaierAC176.

## ◆ setRaw()

void IRHaierACYRW02::setRaw | ( | const uint8_t | new_code[] | ) |
| overridevirtual

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.

Reimplemented from IRHaierAC176.

## ◆ validChecksum()

bool IRHaierACYRW02::validChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kHaierACYRW02StateLength`
| ) |  |
| static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length of the state array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

The documentation for this class was generated from the following files:

- src/ir_Haier.h
- src/ir_Haier.cpp